package com.example.readlinebyline2

import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.view.View
import android.widget.*

class MainActivity : AppCompatActivity() {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)

        val spDogData = findViewById<Spinner>(R.id.spDogData)
        val ivDog = findViewById<ImageView>(R.id.ivDog)
        val tvDogHeight = findViewById<TextView>(R.id.tvDogHeight)
        val tvDogColor = findViewById<TextView>(R.id.tvDogColor)
        val tvDogChar = findViewById<TextView>(R.id.tvDogChar)

        val input_stream = baseContext.resources.openRawResource(R.raw.dog_data)
        // create a BufferedeReader from the input stream in order to read line-by-line
        val buffer = input_stream.bufferedReader()

        val lines = buffer.readLines() // creates a List of strings
        val dogNames: MutableList<String> = ArrayList()

        for(item in lines){
            val tokens = item.split("/")
            dogNames.add(tokens[0])
        }

        //use array of string to populate a spinner
        val aaDogData = ArrayAdapter(this, android.R.layout.simple_spinner_item, dogNames)
        aaDogData.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item) // The drop down view
        spDogData.adapter = aaDogData

        // when item chosen in spinner display same thing in textview
        spDogData.onItemSelectedListener = object : AdapterView.OnItemSelectedListener {
            override fun onItemSelected(adapterView: AdapterView<*>, view: View, i: Int, l: Long) {
                val tvUserItem = view as TextView
                Toast.makeText(applicationContext, "You chose " + tvUserItem.text.toString(), Toast.LENGTH_SHORT).show()
                val tokens = lines[i].split("/")

                var drawable_resource_name = tokens[0].toLowerCase().replace(" ", "_")

                //get the id from the resource name
                val drawable_resouce_id = getResources().getIdentifier(drawable_resource_name,
                    "drawable", getPackageName())
                ivDog.setImageResource(drawable_resouce_id)

                tvDogHeight.text = "Average height: " + tokens[1] +" inches"
                tvDogColor.text = "Colors: " + tokens[2]
                tvDogChar.text = "Characteristics: " + tokens[3]
            }

            override fun onNothingSelected(adapterView: AdapterView<*>) {}
        }//end onItemSelectedListener

    } //end onCreate
} //end MainActivity
